
;   ************************************************************************
;   *				  chainint.asm				   *
;   ************************************************************************

.NOLIST
  INCLUDE		cpu.inc
  INCLUDE		intpack.inc
  INCLUDE		keepsegs.inc
.LIST

.MODEL			SMALL, FARSTACK

;   ========================================================================

.CODE			KEEP_TEXT

ChainIntr		PROC	FAR C PUBLIC

;   void _far _cdecl ChainIntr (void (_cdecl _interrupt _far *) ())

;   This function replaces the Microsoft C library function _chain_intr
;   with more or less equivalent code in the resident KEEP_TEXT segment.
;   Like the usual function, it assumes that SS:BP addresses the registers
;   stacked by the prologue code generated by the _interrupt keyword.  This
;   means that it must be called from the interrupt handler itself, not a
;   subordinate function.

;   When this procedure receives control, the stack will be laid out as
;   follows (from top to bottom):

;	the interrupt caller's flags (word)
;	return address to interrupt caller (dword)
;	stacked registers ax, cx, dx, bx, ... , ds, es (addressed by BP)
;	local variables declared in the interrupt handler (unknown number)
;	the transfer address passed as argument to this function (dword)
;	return address from this function (dword)

;   The aim is to transfer control to the address given as the argument to
;   this function, having first restored the registers from the stack.	The
;   handler to which control is passed should find both the interrupt and
;   trap flags clear, just as it would have done had it been first in the
;   chain.

;   The method adopted is to prepare the flags and transfer address on the
;   stack in the position occupied by ax, cx and dx, then after popping all
;   the other registers from the stack, an iret instruction will transfer
;   control correctly.

			ASSUME	bp:PTR INTPACK

			pop	ax
			pop	ax

			mov	dx,[bp].stacked_dx
			pop	[bp].stacked_dx

			mov	cx,[bp].stacked_cx
			pop	[bp].stacked_cx

			mov	ax,[bp].stacked_flags
			and	ax,NOT (MASK IFbit OR MASK TFbit)
			xchg	ax,[bp].stacked_ax

			mov	sp,bp

			pop	es
			pop	ds
			pop	di
			pop	si
			pop	bp
			pop	bx
			pop	bx

			iret

ChainIntr		ENDP

;   ************************************************************************

END

