
/*  ************************************************************************  *
 *				   closeall.c				      *
 *  ************************************************************************  */

#include    <dos.h>
#include    <stdlib.h>

#include    <psp.h>
#include    <standard.h>

void CloseAllFiles (void)
{
    /*	This function closes all file handles.	Note that there is no
	way to determine at DOS function level the number of open
	handles or even a useful upper bound.  Ordinarily, programs
	written in Microsoft C have a maximum of 20 handles, but the
	user is provided with instructions for increasing this by
	modifying the C run-time module CRT0DAT.

	Each process has its own handle table, the address and size of
	which may be found by inspecting the PSP.  The table consists of
	single-byte indexes into the System File Tables.  The entry FFh
	indicates that no open file is associated with the handle.  The
	Microsoft C library function _dos_close is called to close each
	open handle.  */

    register int handle;
    _segment tableseg;
    register BYTE _based (tableseg) *tableptr;

    #define pspaddr ((struct PSP _far *) MK_FP (_psp, NULL))

    handle = (pspaddr -> wNumberOfHandles);
    if (handle) {
	handle --;
	tableptr = pspaddr -> lpHandleTable + handle;
	tableseg = (_segment) (pspaddr -> lpHandleTable);
	do {
	    if (*tableptr != 0xFF) _dos_close (handle);
	    tableptr --;
	    handle --;
	} while (handle >= 0);
    }
}

/*  ************************************************************************  */

