/*  ************************************************************************  *
 *				   free_env.c				      *
 *  ************************************************************************  */

#include    <dos.h>
#include    <stdlib.h>

#include    <psp.h>
#include    <standard.h>

unsigned FreeEnvironment (void)
{
    /*	This function calls DOS to release the block of memory beginning
	with the program's environment.  It returns a DOS error code if
	the environment exists but cannot be released;	0, otherwise.

	The environment is located by consulting the program's PSP, the
	segment address of which is recorded by the C run-time and made
	available through the variable _psp.  Memory is released by
	calling the Microsoft C library function _dos_freemem ().  */

    _segment envseg;
    unsigned errorcode;

    #define pspaddr ((struct PSP _far *) MK_FP (_psp, NULL))

    envseg = pspaddr -> spEnvironment;
    if (envseg) {
	errorcode = _dos_freemem (envseg);
	if (errorcode == 0) pspaddr -> spEnvironment = 0;
	else return (errorcode);
    }
    return (0);
}

/*  ************************************************************************  */

