
;   ************************************************************************
;   *				   onexit.asm				   *
;   ************************************************************************

.MODEL			SMALL, FARSTACK

;   ========================================================================

.DATA?

;   The table in which function addresses will be recorded is defined in the
;   module containing ExitKeepC, together with a pointer to the location at
;   which to make the next entry.

			EXTERN	XKEEPC_start:DWORD, XKEEPC_end:DWORD

.DATA
			EXTERN	XKEEPC_ptr:WORD

;   ========================================================================

.CODE

AtExitKeepC		PROC	C PUBLIC USES di, func:DWORD

;   Two forms of the function are supported, corresponding to the atexit
;   and onexit functions provided in the standard C library.  They are
;   distinguished by the value returned on failure;  apart from this, they
;   may share the same code.

			OPTION	NOSCOPED

			mov	cx,0FFFFh

			jmp	@f

AtExitKeepC		ENDP

OnExitKeepC		PROC	C PUBLIC USES di, func:DWORD

			xor	cx,cx

@@:

;   Check that space in the table has not been exhausted.

			push	ds
			pop	es
			mov	di,[XKEEPC_ptr]

			cmp	di,OFFSET XKEEPC_end
			jz	fail

;   Enter the function's address.  The opportunity exists to check that the
;   address lies in a resident code segment, but is not taken in this simple
;   version.

			mov	ax,word ptr [func]
			mov	dx,word ptr [func + 02h]

			stosw
			xchg	ax,dx
			stosw
			xchg	ax,dx

			mov	[XKEEPC_ptr],di

;   The onexit form (cx = 0000h) indicates success by returning the function
;   address.  The atexit form returns zero.

			jcxz	done

			xor	ax,ax

			jmp	done

fail:
			mov	ax,cx
			mov	dx,cx

done:
			ret

OnExitKeepC		ENDP

;   ************************************************************************

END

