
/*  ************************************************************************  *
 *				      fp.c				      *
 *  ************************************************************************  */

#include    <dos.h>
#include    <signal.h>

#include    <keepc.h>

/*  The variable _fpinit contains the address at which to call the emulator
    for control - clear this to pretend the emulator was never present, then
    it won't be removed at termination.  Note that robust adaptation of the
    emulator requires knowledge and use of the interface at this address.  */

extern void _far *_fpinit;

extern int _fltused;			// external reference to ensure that
					//   the emulation library is linked

static int _far HardErrorTrap (void)	// fail any critical errors
{					//   while closing file handles
    return (_HARDERR_FAIL);
}

void main (void)
{
    /*	Make sure the external reference to _fltused actually appears in the
	object file.  An alternative is to operate non-trivially on a
	variable of type float, then the compiler will generate the external
	reference itself.  */

    int dummy = _fltused;

    signal (SIGINT, SIG_IGN);		// standard provisions to prevent
    _harderr (HardErrorTrap);		//   premature termination

    _fpinit = 0;			// clear _fpinit, as described above

    CloseAllFiles ();			// tidy up
    FreeEnvironment ();
    ExitKeepC (0, 0);			// keep the emulator's memory
}

/*  ************************************************************************  */

