
/*  ************************************************************************  *
 *				   errormsg.c				      *
 *  ************************************************************************  */

/*  This file demonstrates the retrieval of standard error messages from the
    primary instance of COMMAND.COM in DOS 5.  */

#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>

#include    <standard.h>

/*  Typedef for a counted string - the form in which Pascal strings are
    stored and in which the COMMAND.COM error conversion routines provide
    their results.  */

typedef struct {
    BYTE length;
    CHAR string [];
} LSTRING;

static void _far *QueryTranslator (WORD);
static LSTRING _far *GetMessage (WORD, void _far *);

static void _far *lpTranslator;
static BOOL TranslatorSought = FALSE, TranslatorFound = FALSE;

static void _far *lpDOSErrorTable;

#define DOS_ERRORS	    0
#define PARSE_ERRORS	    2
#define CRITICAL_ERRORS     4
#define TRANSLATOR	    8

static CHAR errorstring [0x100];

/*  ========================================================================  */

CHAR *GetErrormsg (WORD errorcode)
{
    LSTRING _far *ptr;
    register WORD count;

    /*	The lookup procedure begins by finding the COMMAND.COM translator
	and also the table for DOS error codes (there is another for parsing
	errors).  These need be located just once;  if they are not there
	first time, do not seek them again.  */

    if (NOT TranslatorSought) {
	TranslatorSought = TRUE;
	if (_osmajor >= 5) {
	    lpTranslator = QueryTranslator (TRANSLATOR);
	    if (lpTranslator != NULL) TranslatorFound = TRUE;
	    lpDOSErrorTable = QueryTranslator (DOS_ERRORS);
	}
    }

    /*	If the translator has been found, ask it for a message to match the
	error code supplied as this function's argument.  The message is
	returned (by address) as an LSTRING, so convert it to ASCIIZ format
	in a temporary buffer.	*/

    if (TranslatorFound AND (ptr = GetMessage (errorcode, lpDOSErrorTable))) {
	_fmemcpy (errorstring, ptr -> string, count = ptr -> length);
	errorstring [count] = '\0';
    }
    else sprintf (errorstring, "DOS error %02Xh", errorcode);

    return (errorstring);
}

static void _far *QueryTranslator (WORD index)
{
    _asm {
	    xor     di,di	; int 2Fh function 122Eh might not be
	    mov     es,di	; supported and therefore not change es:di
	    mov     dx,index
	    mov     ax,122Eh
	    int     2Fh
	    mov     dx,es
	    mov     ax,di
    }
}

static LSTRING _far *GetMessage (WORD errorcode, void _far *tableptr)
{
    _asm {
	    mov     ax,errorcode
	    les     di,tableptr
	    call    lpTranslator
	    mov     dx,es
	    mov     ax,di
	    jnc     done
	    xor     ax,ax
	    cwd
	done:
    }
}

/*  ************************************************************************  */

