
/*  ************************************************************************  *
 *				    gioctl.c				      *
 *  ************************************************************************  */

#include    <stdlib.h>

#include    <doserror.h>
#include    <drivparm.h>
#include    <standard.h>

/*  The following functions invoke the Generic IOCTL interface with block
    device drivers.  They return zero on success and indicate failure
    through a normal DOS error code.  For greater definition, extended error
    information should be sought immediately after the function returns.
    Device driver errors occurring during Generic IOCTL functions do not
    generate int 24h exceptions.  */

static WORD _dos_gioctl (BYTE minorcode, WORD drive, void _far *data)
{
    _asm {
	    mov     ch,08h	    ; special value for disk services
	    mov     cl,minorcode
	    mov     bx,drive

    /*	If the DOS version is at least 5, check first that the device driver
	supports this particular minor code.  */

	    cmp     _osmajor,5
	    jb	    ok

	    mov     ax,4411h
	    int     21h
	    jnc     ok

	    cmp     ax,E_ACCESS_DENIED
	    jz	    done

	ok:

    /*	If the minor code is not specifically rejected, proceed with the
	Generic IOCTL command.	*/

	    push    ds
	    lds     dx,data
	    mov     ax,440Dh
	    int     21h
	    pop     ds
	    jc	    done
	    xor     ax,ax

	done:
    }
}

WORD _dos_getdrivparm (WORD drive, struct DRIVPARM *parmptr)
{
    return (_dos_gioctl (0x60, drive, parmptr));
}

WORD _dos_setdrivparm (WORD drive, struct DRIVPARM *parmptr)
{
    return (_dos_gioctl (0x40, drive, parmptr));
}

WORD _dos_readtrack (WORD drive, struct RWBLOCK *rwptr)
{
    return (_dos_gioctl (0x61, drive, rwptr));
}

WORD _dos_writetrack (WORD drive, struct RWBLOCK *rwptr)
{
    return (_dos_gioctl (0x41, drive, rwptr));
}

WORD _dos_getmediaid (WORD drive, struct MEDIA_ID *idptr)
{
    return (_dos_gioctl (0x66, drive, idptr));
}

WORD _dos_setmediaid (WORD drive, struct MEDIA_ID *idptr)
{
    return (_dos_gioctl (0x46, drive, idptr));
}

/*  ************************************************************************  */

