
/*  ************************************************************************  *
 *				     mem.c				      *
 *  ************************************************************************  */

#include    <dos.h>
#include    <string.h>

#include    <standard.h>

#include    "storage.h"

static DWORD CreateMem (DWORD);
static BOOL DestroyMem (void);
static WORD ReadMem (void _far *, WORD);
static WORD WriteMem (void _far *, WORD);
static BOOL RewindMem (void);

struct STORAGE_MEDIUM MemStorage =
    {0, 0, 0, CreateMem, DestroyMem, ReadMem, WriteMem, RewindMem};

static _segment mem_seg = 0;
static DWORD mem_ptr = 0, mem_end = 0, mem_size = 0;

static DWORD CreateMem (DWORD requirement)
{
    DWORD paras;
    WORD temp;

    paras = (requirement + 15) >> 4;
    if (HIGHWORD (paras)) paras = 0xFFFF;

    if (_dos_allocmem ((WORD) paras, &temp) == 0) mem_size = requirement;
    else {
	paras = temp;
	if (_dos_allocmem ((WORD) paras, &temp) == 0) mem_size = paras << 4;
	else return (0);
    }
    mem_seg = temp;
    mem_ptr = mem_end = 0;
    return (mem_size);
}

static BOOL DestroyMem (void)
{
    if (mem_seg) {
	_dos_freemem (mem_seg);
	mem_seg = 0;
    }
    return (TRUE);
}

static WORD ReadMem (void _far *buffer, WORD count)
{
    DWORD avail;
    BYTE _far *src;

    avail = mem_end - mem_ptr;
    if (avail < count) count = (WORD) avail;

    if (count) {
	src = (BYTE _huge *) MK_FP (mem_seg, NULL) + mem_ptr;
	_fmemcpy (buffer, src, count);
	mem_ptr += count;
    }
    return (count);
}

static WORD WriteMem (void _far *buffer, WORD count)
{
    DWORD avail;
    BYTE _far *dest;

    avail = mem_size - mem_ptr;
    if (avail < count) count = (WORD) avail;

    if (count) {
	dest = (BYTE _huge *) MK_FP (mem_seg, NULL) + mem_ptr;
	_fmemcpy (dest, buffer, count);
	mem_ptr += count;
	if (mem_ptr > mem_end) mem_end = mem_ptr;
    }
    return (count);
}

static BOOL RewindMem (void)
{
    mem_ptr = 0;
    return (TRUE);
}

/*  ************************************************************************  */

