
/*  ************************************************************************  *
 *				     cpu.h				      *
 *  ************************************************************************  */

/*  Structures and definitions for 80x86 properties  */

#ifndef     _CPU_INC
#define     _CPU_INC

#pragma pack (1)

/*  Arrangement of registers on stack for PUSHA and POPA instructions:	*/

struct PUSHA_STACK {
    unsigned di;
    unsigned si;
    unsigned bp;
    unsigned sp;
    union {
	unsigned bx;
	struct {
	    unsigned char bl, bh;
	};
    };
    union {
	unsigned dx;
	struct {
	    unsigned char dl, dh;
	};
    };
    union {
	unsigned cx;
	struct {
	    unsigned char cl, ch;
	};
    };
    union {
	unsigned ax;
	struct {
	    unsigned char al, ah;
	};
    };
};

/*  Forms of return address pushed onto stack:	*/

union FAR_RETADDR {
    void _far *retaddr;
    struct {
	unsigned ip;
	unsigned cs;
    };
};

struct INT_RETADDR {
    union FAR_RETADDR;
    unsigned flags;
};

#pragma pack ()

#endif

/*  ************************************************************************  */

