
/*  ************************************************************************  *
 *				   doserror.h				      *
 *  ************************************************************************  */

#ifndef     _DOSERROR_INC
#define     _DOSERROR_INC

/*  Symbols for DOS error codes - as given in Appendix C to the Microsoft
    MS-DOS Programmer's Reference  */

#define     E_INVALID_FUNCTION		0x01
#define     E_FILE_NOT_FOUND		0x02
#define     E_PATH_NOT_FOUND		0x03
#define     E_TOO_MANY_OPEN_FILES	0x04
#define     E_ACCESS_DENIED		0x05
#define     E_INVALID_HANDLE		0x06
#define     E_ARENA_TRASHED		0x07
#define     E_OUT_OF_MEMORY		0x08
#define     E_INVALID_BLOCK		0x09
#define     E_BAD_ENVIRONMENT		0x0A
#define     E_BAD_FORMAT		0x0B
#define     E_INVALID_ACCESS		0x0C
#define     E_INVALID_DATA		0x0D

#define     E_INVALID_DRIVE		0x0F
#define     E_CURRENT_DIRECTORY 	0x10
#define     E_NOT_SAME_DEVICE		0x11
#define     E_NO_MORE_FILES		0x12
#define     E_WRITE_PROTECT		0x13
#define     E_BAD_UNIT			0x14
#define     E_NOT_READY 		0x15
#define     E_BAD_COMMAND		0x16
#define     E_CRC			0x17
#define     E_BAD_LENGTH		0x18
#define     E_SEEK			0x19
#define     E_NOT_DOS_DISK		0x1A
#define     E_SECTOR_NOT_FOUND		0x1B
#define     E_OUT_OF_PAPER		0x1C
#define     E_WRITE_FAULT		0x1D
#define     E_READ_FAULT		0x1E
#define     E_GEN_FAILURE		0x1F
#define     E_SHARING_VIOLATION 	0x20
#define     E_LOCK_VIOLATION		0x21
#define     E_WRONG_DISK		0x22
#define     E_FCB_UNAVAILABLE		0x23
#define     E_SHARING_BUFFER_EXCEEDED	0x24
#define     E_CODE_PAGE_MISMATCHED	0x25
#define     E_HANDLE_EOF		0x26
#define     E_HANDLE_DISK_FULL		0x27

#define     E_NOT_SUPPORTED		0x32
#define     E_REN_NOT_LIST		0x33
#define     E_DUP_NAME			0x34
#define     E_BAD_NETPATH		0x35
#define     E_NETWORK_BUSY		0x36
#define     E_DEV_NOT_EXIST		0x37
#define     E_TOO_MANY_CMDS		0x38
#define     E_ADAP_HDW_ERROR		0x39
#define     E_BAD_NET_RESP		0x3A
#define     E_UNEXP_NET_ERR		0x3B
#define     E_BAD_REM_ADAP		0x3C
#define     E_PRINTQ_FULL		0x3D
#define     E_NO_SPOOL_SPACE		0x3E
#define     E_PRINT_CANCELLED		0x3F
#define     E_NETNAME_DELETED		0x40
#define     E_NETWORK_ACCESS_DENIED	0x41
#define     E_BAD_DEV_TYPE		0x42
#define     E_BAD_NET_NAME		0x43
#define     E_TOO_MANY_NAMES		0x44
#define     E_TOO_MANY_SESS		0x45
#define     E_SHARING_PAUSED		0x46
#define     E_REQ_NOT_ACCEP		0x47
#define     E_REDIR_PAUSED		0x48

#define     E_FILE_EXISTS		0x50
#define     E_DUP_FCB			0x51
#define     E_CANNOT_MAKE		0x52
#define     E_FAIL_I24			0x53
#define     E_OUT_OF_STRUCTURES 	0x54
#define     E_ALREADY_ASSIGNED		0x55
#define     E_INVALID_PASSWORD		0x56
#define     E_INVALID_PARAMETER 	0x57
#define     E_NET_WRITE_FAULT		0x58

#define     E_SYS_COMP_NOT_LOADED	0x5A

#endif

/*  ************************************************************************  */

