
/*  ************************************************************************  *
 *				   drivparm.h				      *
 *  ************************************************************************  */

#ifndef     _DRIVPARM_INC
#define     _DRIVPARM_INC

#include    <bpb.h>
#include    <standard.h>

#pragma pack (1)

/*  Structure for minor codes 0x40 and 0x60, which set and get drive
    parameters respectively  */

struct DRIVPARM {
    BYTE cSpecial;
    BYTE cDeviceType;
    WORD wDeviceAttributes;
    WORD wCylinders;
    BYTE cMediaType;
    struct BPB bpb;
    BYTE reserved [6];
    WORD wSectorsInTable;
    struct SECTORPARM {
	WORD wNumber;
	WORD wSize;
    } tracklayout [63];
};

/*  Values for cSpecial  */

#define     DRIVPARM_DEFAULT		    0x00
#define     DRIVPARM_CURRENT		    0x01
#define     SET_TRACKLAYOUT_ONLY	    0x02
#define     SET_GOOD_TRACKLAYOUT	    0x04

/*  Values for cDeviceType  */

#define     DRIVE_360		0x00
#define     DRIVE_1200		0x01
#define     DRIVE_720		0x02
#define     DRIVE_8INCHSINGLE	0x03
#define     DRIVE_8INCHDOUBLE	0x04
#define     DRIVE_HARDDISK	0x05
#define     DRIVE_TAPE		0x06
#define     DRIVE_1440		0x07
#define     DRIVE_OPTICAL	0x08
#define     DRIVE_2880		0x09

/*  Bit masks for wDeviceAttributes  */

#define     DRIVE_FIXED 	0x01
#define     DRIVE_CHANGELINE	0x02

/*  Structure for minor codes 0x61 and 0x41, which read/write sectors from a
    track.  */

struct RWBLOCK {
    BYTE cSpecial;
    WORD wHead;
    WORD wCylinder;
    WORD wFirstSector;
    WORD wSectors;
    void _far *lpBuffer;
};

/*  Structure for minor codes 0x66 and 0x46, which work with standard forms
    of media identifiers.  */

struct MEDIAID {
    WORD wInfoLevel;
    DWORD dwSerialNumber;
    CHAR cVolumeLabel [11];
    CHAR cFileSystem [8];
};

#pragma pack ()

#endif

/*  ************************************************************************  */

