
/*  ************************************************************************  *
 *				    keepc.h				      *
 *  ************************************************************************  */

/*  Definitions and function prototypes for use with the KEEPC library  */

/*  A pseudo-keyword _RESIDENT is provided to help with references to
    resident data.  */

#ifndef _RESIDENT_DEFINED
#ifndef _KEEP_
static _segment spKEEP = _segname ("KEEP");
#define _RESIDENT _based (spKEEP)
#else
#define _RESIDENT
#endif
#define _RESIDENT_DEFINED
#endif

/*  The default break address - held in DGROUP and therefore unavailable
    to the resident part of a program:  */

extern void _far *lpBreakAddress;

/*  Functions declared in the resident code segment KEEP_TEXT  */

void _far _cdecl ChainIntr (void (_cdecl _interrupt _far *) ());

unsigned long _cdecl shl (unsigned long, unsigned);
unsigned long _cdecl shr (unsigned long, unsigned);

/*  Functions declared in the non-resident code segment _TEXT  */

typedef void (_cdecl _far *XKEEPC) (void);

int _cdecl AtExitKeepC (XKEEPC);
void _cdecl CloseAllFiles (void);
void _cdecl ExitKeepC (unsigned, void _far *);
unsigned _cdecl FreeEnvironment (void);
XKEEPC _cdecl OnExitKeepC (XKEEPC);

/*  ************************************************************************  */

