
/*  ************************************************************************  *
 *				   smartdrv.h				      *
 *  ************************************************************************  */

#ifndef     _SMARTDRV_INC
#define     _SMARTDRV_INC

#pragma pack (1)

/*  The data packet returned by performing an IOCTL Read from SMARTDrive  */

struct SD_READ {

    char unused_1;
    char unused_2;
    char IsActive;
    char MemoryType;
    unsigned Ticks;
    char IsLocked;
    char FlushOnReboot;
    char unused_3;
    char DoubleBuffer;
    void _far *OrgInt13;
    char MinorVersion;
    char MajorVersion;
    char unused_4;
    char unused_5;

    unsigned SectorsRead;
    unsigned SectorsHit;
    unsigned SectorsBuffered;
    char HitRatio;
    char BufferRatio;

    unsigned TracksInCache;
    unsigned CurrentTracks;
    unsigned LockedTracks;
    unsigned DirtyTracks;

    unsigned CurrentSize;
    unsigned MaximumSize;
    unsigned MinimumSize;

    char _far *GlobalLockFlag;

};

struct SD_WRITE {
    char command;
    union {
	char subcommand;
	int size;
	char _far *address;
    } data;
};

#define     SD_FLUSH_DIRTY	    0x00
#define     SD_RESET		    0x01
#define     SD_DEACTIVATE	    0x02
#define     SD_ACTIVATE 	    0x03
#define     SD_MARK_NONDISCARDABLE  0x06
#define     SD_MARK_DISCARDABLE     0x07
#define     SD_FLUSH_ON_REBOOT	    0x08
#define     SD_DECREASE_CACHE	    0x0B
#define     SD_INCREASE_CACHE	    0x0C
#define     SD_SET_INT13	    0x0D

#pragma pack ()

#endif

/*  ********************************************************************  */

