
/*  ************************************************************************  *
 *				   is80386.c				      *
 *  ************************************************************************  */

int Is80386 (void)
{
    _asm {
	    pushf		;  save flags - particularly the interrupt
				;  flag, which is cleared during the test

	    mov     ax,7000h	;  try setting the NT and IOPL bits
	    push    ax		;  but clearing the reserved bit F
	    popf

	    pushf
	    pop     ax
	    test    ax,8000h
	    jnz     no		;  if bit F comes on, then 8086 or 80186

	    test    ax,7000h
	    or	    ax,ax
	    jz	    no		;  if other bits stay clear, then 80286

	    mov     ax,0001h	;  return TRUE for an 80386 or better
	    jmp     done

	no:
	    xor     ax,ax	;  else return FALSE

	done:
	    popf		;  restore original flags
    }
}

/*  ************************************************************************  */

