
/*  ************************************************************************  *
 *				   readhex.c				      *
 *  ************************************************************************  */

#include    <standard.h>

BOOL ReadHexWord (register char *ptr, WORD *result)
{
    register WORD ch;
    WORD temp = 0;

    ch = *ptr;					    // be kind to users
    if (ch == '0' OR ch == '\\') {                  // accustomed to C-style
	if ((ptr [1] & ~0x20) == 'X') ptr += 2;     // expressions beginning
    }						    // with "\x" or "0x"

    while (*ptr == '0') ptr ++;                     // skip leading zeros

    while (ch = *ptr ++) {
	if (ch >= '0' AND ch <= '9') ch -= '0';             // decimal digit
	else {
	    ch &= ~0x20;
	    if (ch >= 'A' AND ch <= 'F') ch -= ('A' - 10);  // hex digit
	    else if (ch == 'H') break;                      // final 'h'
	    else return (FALSE);
	}
	if (temp & 0xF000) return (FALSE);	    // accumulate result
	temp <<= 4;				    // in temp, guarding
	temp += ch;				    // against overflow
    }
    *result = temp;
    return (TRUE);
}

/*  ************************************************************************  */

