
/*  ************************************************************************  *
 *				    sdinit.c				      *
 *  ************************************************************************  */

/*  This file performs some initialisation specific to using the
    SMARTDRV.SYS disk cache as a source of additional memory for the XMSFILE
    clipboard.	*/

#include    <stdlib.h>

#include    <keepc.h>
#include    <sft.h>
#include    <standard.h>

/*  The address of a variable in the DOS kernel data area - needed if
    accessing the SMARTDrive cache's device while already executing an
    int 21h function.  */

extern struct SFT _far * _far * _RESIDENT lpSFTPointer;     // in smartdrv.c

extern void PutWarning (CHAR *, ...);			    // in main.c

BOOL InitSMARTDrive (WORD clustersizeinkb)
{
    register _segment KernelSegment;
    register WORD KernelDataFormat;

    /*	Check that additional memory will be sought in multiples of the same
	unit (16KB) that SMARTDrive uses for resizing its memory allocation.
	It is assumed here that the clustersizeinkb argument is already
	known to be a power of 2.  */

    if (clustersizeinkb < 16) {
	PutWarning ("clustersize too small to support use of SMARTDrive");
	return (FALSE);
    }

    /*	For safe use of SMARTDrive while already processing DOS functions,
	obtain the address of the DOS kernel variable that must be
	preserved.  */

    _asm {
	    mov     ah,52h
	    int     21h
	    mov     KernelSegment,es
    }
    KernelDataFormat = *((WORD _far *) MK_FP (KernelSegment, 0x0004));

    if (KernelDataFormat != (WORD) (_osmajor < 4 ? 0 : 1)) {
	PutWarning ("unrecognised DOS version - cannot use SMARTDrive");
	return (FALSE);
    }

    lpSFTPointer = (struct SFT _far * _far *)
	    MK_FP (KernelSegment, KernelDataFormat == 0 ? 0x0536 : 0x059E);

    return (TRUE);
}

/*  ************************************************************************  */

