
/*  ************************************************************************  *
 *				     api.c				      *
 *  ************************************************************************  */

/*  This resident module provides a device driver interface through which
    XMSWATCH returns information about XMS allocations.  */

#include    <driver.h>
#include    <standard.h>

#include    "xmswatch.h"

extern WORD wHandles, wHandleTableSize;
extern struct HANDLE *pHandleTable;

extern void (_far *lpNextXMS) (void);

static void CopyWatchData (struct XMSWATCH _far *);
static void CopyHandleTable (BYTE _far *);

/*  ========================================================================  */

/*  Provide information as control data for the XMSWWWW0 device.  At DOS
    function level, this means supporting the IOCTL Read function (4402h)
    for which the caller indicates the number of bytes it expects the device
    to copy to a given buffer.	The caller should first ask for the XMSWATCH
    structure (whose size is fixed).  One of that structure's fields is the
    size of the handle table (which depends on the number of XMS handles
    available when XMSWATCH is installed).  A second IOCTL Read should then
    return the whole handle table.  */

WORD DrvrProcIOCTLRead (struct REQUEST_HEADER _far *lpReqHdr)
{
    if (lpReqHdr -> wCount) {
	if (lpReqHdr -> wCount == sizeof (struct XMSWATCH))
	    CopyWatchData ((struct XMSWATCH _far *) lpReqHdr -> lpBuffer);
	else if (lpReqHdr -> wCount == wHandleTableSize)
	    CopyHandleTable (lpReqHdr -> lpBuffer);
	else lpReqHdr -> wCount = 0;
    }
    return (D_DONE);
}

static void CopyWatchData (struct XMSWATCH _far *ptr)
{
    ptr -> wVersion = XMSWATCH_VERSION;
    ptr -> wHandles = wHandles;
    ptr -> wHandleTableSize = wHandleTableSize;
    ptr -> lpNextXMS = lpNextXMS;
}

static void CopyHandleTable (BYTE _far *ptr)
{
    register BYTE *src = (BYTE *) pHandleTable;
    register BYTE _based ((_segment) ptr) *dest = ptr;
    WORD n = wHandleTableSize;

    do {
	*dest ++ = *src ++;
    } while (-- n);
}

/*  ************************************************************************  */

